<?
$GLOBALS['functionsversion']='1.0.2';
require_once( 'DB.php' );
if ( ! class_exists("DB") ){
    print("Error: PEAR::DB not found.\n");
    exit;
}

$GLOBALS['defaults']['limit']=5;
$GLOBALS['defaults']['title']="Parasite Weblog";
$GLOBALS['defaults']['url']="http://www.example.com/parasite/";
$GLOBALS['defaults']['cssfile']=$defaults['url']."parasite.css";
$GLOBALS['defaults']['articleurl']=$defaults['url']."article";
$GLOBALS['defaults']['pingback']='1';
$GLOBALS['defaults']['pingbackstr']='checked="checked"';
$GLOBALS['defaults']['useweblogping']='1';
$GLOBALS['defaults']['useweblogpingstr']='checked="checked"';
$GLOBALS['defaults']['description']="My Little Parasite";
$GLOBALS['defaults']['defaultuser']='Mr. Magic';
$GLOBALS['defaults']['usearticletitles']='1';
$GLOBALS['defaults']['usearticletitlesstr']='checked="checked"';
$GLOBALS['defaults']['rssv2']='1';
$GLOBALS['defaults']['rssv2str']='checked="checked"';
$GLOBALS['defaults']['rssv2limit']='5';
$GLOBALS['defaults']['rssimgurl']='http://www.example.com/parasite/rssimg.png';
$GLOBALS['defaults']['articledefinition']='
<div class="articlecontainer">
    <div class="ah">
        <a name="|thisarticlenumber|"></a>
        <div class="articletitle">|thisarticletitle|</div>
        <div class="date">|thisarticledate|</div>
        <div class="user">by |thisarticleuser|</div>
    </div>
    <div class="article">
        |thisarticlebody|
        <div class="permalink">
            |thisarticlepermalink|
        </div>
        <div class="pingbacks">
            |thisarticlepingbacktotal|
        </div>
        <div class="|pingbackclass|" id="|thisarticlepingbackid|" style="display:none;">
            |thisarticlepingbacklist| 
        </div>
    </div>
</div>
';
$GLOBALS['defaults']['pingbacktotaldefinition']='
<a href="#" onclick="makevis(\'|thisarticlenumber|pingbacks\'); return false;" title="Pingbacks for |thisarticletitle|">pingbacks: |pingbacktotal|</a>
';
$GLOBALS['defaults']['pingbacklistdefinition']='
    <a href="|thispingbackremoteurl|" title="|thispingbackremotetitle|">|thispingbackremotetitle|</a>, |thispingbacktime| <br />
';

$GLOBALS['config']['dbstring'] = $GLOBALS['config']['dbtype'].'://'.$GLOBALS['config']['dbuser'].':'.$GLOBALS['config']['dbpass'].'@'.$GLOBALS['config']['dbhost'].'/'.$GLOBALS['config']['dbname'];
getconfig();
if ( $GLOBALS['config']['pingback'] == 1 || $GLOBALS['config']['useweblogping'] == 1 ){
    include("xmlrpc.php");
}

$GLOBALS['config']['limitconstant']=$GLOBALS['config']['limit'];
$GLOBALS['config']['pingbackserver']=$GLOBALS['config']['url'].'pingback.php';
$GLOBALS['config']['articleurl']=$GLOBALS['config']['url'].'article';

/* 
    This function does the initial entry of an article into the database.
    It is used by the maintenence page.
    DB structure:
              time,body,visible,username,id,title
*/

function 
publish_article($time,$body,$visible,$user,$arttitle,$pingbackcheck){
    $error = '';
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    // A whole extra table that creates weird sync issues? No thanks.
    //$ID = $db->nextID('id',TRUE);
    $ID = getmaxid($db);
    $ID++;
    if ( $usearticletitles == 1 ){
        $sql="INSERT INTO articles VALUES ('$time','$body','$visible','$user','$ID','$arttitle')";
    }else{
        $sql="INSERT INTO articles VALUES ('$time','$body','$visible','$user','$ID','$arttitle')";
    }
    $result=$db->query($sql) or die($sql);
    if ( $GLOBALS['config']['pingback'] == 1 && $visible == 1 && $pingbackcheck == 1 ){
        $sql="SELECT id FROM articles where TIME=$time";
        $result = $db->query($sql) or die( $sql );
        $id = $result->fetchRow();
        $id = $id[0];
        $error = pingbackcheck($body,$id);
    }
    $db->disconnect();
    return $error;
}


/* 
    This function updates the content of a specific article
    identified by ID. It is used by the post-submission editor.
    DB structure:
                  time,body,visible,username,id,title
*/

function 
update_article($id,$body,$user,$arttitle,$vis,$pingback){
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    $sql="UPDATE articles SET body='$body' WHERE id=$id";
    $result=$db->query($sql) or die($sql);
    $sql="UPDATE articles SET username='$user' WHERE id=$id";
    $result=$db->query($sql) or die($sql);
    if ( $GLOBALS['config']['usearticletitles'] == 1 ){
        $sql="UPDATE articles SET title='$arttitle' WHERE id=$id";
        $result=$db->query($sql) or die($sql);
    }
    if ( $GLOBALS['config']['pingback'] == 1 && $pingback == 1 && $vis == 1 ){
        $error = pingbackcheck($body,$id);
    }
    $db->disconnect();
    return $error;
}


/* 
    This function updates the time-stamp associated with a specific article
    identified by ID. It is used by the post-submission editor.
    Since version 0.5 this function is no longer used. It seems a bit
    pointless to update a timestamp when the timestamp doesn't change the
    presentation order. I leave it here for historical purposes. What 
    purposes, you ask? Historical ones.
*/

function 
update_articletime($id,$time){
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    $sql="UPDATE articles SET time='$time' WHERE id=$id";
    $result=$db->query($sql) or die($sql);
    $db->disconnect();
    return TRUE;
}


/* 
    This function changes the visiblity flag for a specific article 
    identified by ID. It is used by the post-submission editor.
*/

function
changevisibility($id,$visibility){
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    $sql="UPDATE articles SET visible='$visibility' where id=$id";
    $result=$db->query($sql) or die($sql);
    $db->disconnect();
    return TRUE;
}


/* 
    This function returns an array contaning the ID values returned
    by searching for type $vis (0 for postponed, 1 for visible, d for deleted)
    It is used by the log, rss and maintenence pages.
    This function and getarticle() differ from the other functions, in that
    they don't have the DB connect strings in them because they're often
    used in loops or at least with each other. Database connections are
    the slowest part of database STUFF so minimize them when you can.
*/

function
numvisarticles($vis,$db){
    $sql = "SELECT id FROM articles WHERE visible='$vis'";
    $articleResult = $db->query($sql) or die( $sql );

    while ($articleRow = $articleResult->fetchRow()) {
        $artnums[]=$articleRow[0];
    }
    
    return $artnums;
}


/* 
    This function returns an associative array containing the various
    parts of an article when given a specific ID number. This function is
    used by the main page and the post-submission article editor.
    This function and numvisarticles() differ from the other functions, in 
    that they don't have the DB connect strings in them because they're often
    used in loops or at least with each other. Database connections are
    the slowest part of database STUFF so minimize them when you can.
    DB structure:
                  time,body,visible,username,id,title
*/

function
getarticle($id,$db){
    $sql = "SELECT * FROM articles WHERE id=$id";
    $articleResult = $db->query($sql) or die( $sql );
    $articleRow = $articleResult->fetchRow();
    $article['time'] = $articleRow[0];
    $article['body']=$articleRow[1];
    $article['visible']=$articleRow[2];
    $article['user']=$articleRow[3];
    $article['title']=$articleRow[5];

    return $article;
}

/* 
    getarticleitem() is used to retrieve one particular piece of an article.
    That piece is specified in the $item variable. $item can be any of the 
    items listed in getarticle() above. It returns a string.
*/

function
getarticleitem($item,$id,$db){
    $sql = "SELECT $item FROM articles WHERE id=$id";
    $articleResult = $db->query($sql) or die( $sql );
    $articleRow = $articleResult->fetchRow();
    return stripslashes($articleRow[0]);
}

function
getmaxid($db){
    $sql = "SELECT max(id) FROM articles";
    $max = $db->query($sql) or die( $sql );
    $maxRow = $max->fetchRow();
    return $maxRow[0];
}

// This function is used for new articles and editing existing articles.

function
articlemaint($id=NULL,$articlebody=NULL,$user=NULL,$articletitle=NULL){

    // If we have an ID, we'll need to pull it from the database
    // UNLESS we have content in $articlebody, which means we're a preview
    if ( $id != NULL && empty($articlebody) ){
        $db = DB::connect( $GLOBALS['config']['dbstring'] );
        $contents=getarticle($id,$db);
        $db->disconnect();
        // Since our variable names differ, we'll want to make them the same.
        $articlebody=$contents['body'];
        $articletitle=$contents['title'];
        $user=$contents['user'];
        $time=$contents['time'];
    }

    if ( $user === NULL ){
        $user=$GLOBALS['config']['defaultuser'];
    }

    $str='<form action="'.$_SERVER['PHP_SELF'].'" method="post" name="fd">'."\n";
    if ( $id != NULL ){
        $str.='<input type="hidden" name="time" value="'.$time.'" />'."\n";
    }
    if ( $GLOBALS['config']['usearticletitles'] == 1 ){
        $str.='<label accesskey="t" for="title">Title :</label>';
        $str.='<input type="text" id="title" name="articletitle" value="'.escape($articletitle).'" class="title" />'."\n";
    }
    $str.='<label accesskey="u" for="user">User : </label>';
    $str.='<input type="text" id="user" name="user" value="'.$user.'" class="user" />'."\n\n";

    $str.="<br /><br />\n";
    if ( empty($id) ){
        $str.='<label accesskey="a" for="article">New Article:</label><br />'."\n";
    }else{
        $str.='<label accesskey="a" for="article">Editing Article '.$id.' :</label><br />'."\n";
    }
    //javascript
    $str.='<script language="Javascript">
<!--
function getMozSelection() {
  return document.getSelection();
}

// IE only - stores the current cursor position on any textarea activity
  function storeCaret (txtarea) { 
    if (txtarea.createTextRange) { 
      txtarea.caretPos = document.selection.createRange().duplicate();
    } 
  } 

// IE only - wraps selected text with lft and rgt
  function WrapIE(lft, rgt) {
    strSelection = document.selection.createRange().text;
    if (strSelection!="") {
      document.selection.createRange().text = lft + strSelection + rgt;
    }
  }

// Moz only - wraps selected text with lft and rgt
  function wrapMoz(txtarea, lft, rgt) {
    var selLength = txtarea.textLength;
    var selStart = txtarea.selectionStart;
    var selEnd = txtarea.selectionEnd;
    if (selEnd==1 || selEnd==2) selEnd=selLength;
    var s1 = (txtarea.value).substring(0,selStart);
    var s2 = (txtarea.value).substring(selStart, selEnd)
    var s3 = (txtarea.value).substring(selEnd, selLength);
    txtarea.value = s1 + lft + s2 + rgt + s3;
  }
  
// Chooses technique based on browser
  function wrapTag(txtarea, lft, rgt) {
    lft = unescape(lft);
    rgt = unescape(rgt);
    if (document.all) {
      WrapIE(lft, rgt);
    }
    else if (document.getElementById) {
      wrapMoz(txtarea, lft, rgt);
    }
  }

// Get a link via a prompt and wrap selected text
  function wrapWithLink(txtarea) {
    var my_link = prompt("URL (include protcol!):","");
    if (my_link == null){
        return;
    }
    var my_title = prompt("Title","");
    if (my_link != \'\') {
      lft="<a href=\"" + my_link + "\"";
    }
    if (my_title != \'\') {
        lft = lft + " title=\"" + my_title + "\">";
    }else{
        lft = lft + ">";
    }
    if (my_link != \'\') {
      rgt="</a>";
      wrapTag(txtarea, lft, rgt);
    }
    return;
  }

// IE only - Insert text at caret position or at start of selected text
  function insertIE (txtarea, text) {
    if (txtarea.createTextRange && txtarea.caretPos) { 
      var caretPos = txtarea.caretPos; 
      caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == \' \' ? text+caretPos.text + \' \' : text+caretPos.text;
    } else {
      txtarea.value = txtarea.value + text; 
    }
    return;
  } 

// Moz only - Insert text at caret position or at start of selected text
  function insertMoz(txtarea , lft) {
    var rgt="";
    wrapTag(txtarea, lft, rgt);
    return;
  }

// Switch function based on browser - Insert text at caret position or at start of selected text
  function insertTag(txtarea , lft) {
    if (document.all) {
      insertIE(txtarea, lft);
    }
    else if (document.getElementById) {
      insertMoz(txtarea, lft);
    }
  }
    
// prompt for image name. Insert image at caret position or at start of selected text
  function insertImage(txtarea) {
    var my_link = prompt("IMG URL (include protocol!):","");
    if (my_link == null){
        return;
    }
    if (my_link != \'\') {
      lft="<img src=\"" + my_link + "\" />";
      insertTag(txtarea, lft);
    }
    return;
  }

// End Processing code.

/*
  written by meg hourihan
  http://www.megnut.com
  meg@megnut.com
  
  warning: it only works for IE4+/Win and Moz1.1+
  feel free to take it for your site
  but leave this text in place.
  any problems, let meg know.
  */
  
  function mouseover(el) {
    el.className = "raise";
  }
  
  function mouseout(el) {
    el.className = "buttons";
  }
  
  function mousedown(el) {
    el.className = "press";
  }
  
  function mouseup(el) {
    el.className = "raise";
  }
  /* end meg script */



//-->
</script>';
    // toolbar
    $str.='<div id="toolbar">
<img src="tag_p.png" width="16" height="16"
  title="Highlight some text and click for Paragraph tags"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);"  onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<p>\', \'</p>\');">
<img src="tag_bold.png" width="16" height="16"
  title="Highlight some text and click for bold"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);"  onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<b>\', \'</b>\');">
<img src="tag_i.png" width="16" height="16"
  title="Highlight some text and click for italic"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);"  onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<i>\', \'</i>\')">
<img src="tag_u.png" width="16" height="16"
  title="Highlight some text and click for underlined"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);"  onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<u>\', \'</u>\')">
<img src="div_center.png" width="16" height="16"
  title="Highlight some text and click to center"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);"  onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<div align=%22center%22>\', \'</div>\')">
<img src="div_right.png" width="16" height="16"
  title="Highlight some text and click to right align"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);"  onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<div align=%22right%22>\', \'</div>\')">
<img src="blockquote.png" width="16" height="16"
  title="Highlight some text and click for a blockquote"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);"  onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<blockquote>\', \'</blockquote>\')">
<img src="tag_li.png" width="16" height="16"
  title="Highlight some text and click for a bulleted list"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);" onmousedown="mousedown(this);"  onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<li>\', \'</li>\')">
<img src="tag_pre.png" width="16" height="16"
  title="Highlight some text and click for pre"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);" onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapTag(elements[\'articlebody\'], \'<pre>\', \'</pre>\')">
<img src="tag_image.png" width="16" height="16"
  title="Insert an image"
  class="buttons" onmouseover="mouseover(this);" onmouseout="mouseout(this);" onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="insertImage(elements[\'articlebody\']);">
<img src="tag_a.png" width="16" height="16"
  title="Highlight some text and click to add a link"
  class="buttons"  onmouseover="mouseover(this);" onmouseout="mouseout(this);"  onmousedown="mousedown(this);" onmouseup="mouseup(this);"
  onclick="wrapWithLink(elements[\'articlebody\']);">
</div>
<!-- End of Toolbar block -->';
    //textarea
    $str.="\n\n".'<textarea cols="55" rows="25" name="articlebody" id="article" class="articlebody" onselect="storeCaret(this);" onclick="storeCaret(this);" onkeyup="storeCaret(this);">'.escape($articlebody).'</textarea><br />'."\n";

    $str.="<div><div class=\"floaty\">\n<input type=\"image\" src=\"save.png\" height=\"24\" width=\"24\" title=\"Save Changes\" value=\"Save Changes\" accesskey=\"s\" align=\"middle\" class=\"save\" />\n";
    $str.='<input type="hidden" name="id" value="'.$id.'" />'."\n";
    $str.='<input type="image" src="preview.png" height="24" width="24" name="action" value="Preview" title="Preview" align="middle" accesskey="p" class="preview" />'."\n";
    $str.='<input type="image" src="spellcheck.png" height="24" width="24" name="action" value="SpellCheck" title="SpellCheck" align="middle" accesskey="k" class="spellcheck" id="spellcheck" />'."\n";
    $str.="</div>\n";

    $str.="<div class=\"floaty\">\n<input type=\"checkbox\" name=\"visible\" value=\"1\" checked=\"checked\" class=\"visible\" onclick=\"checkState();return true;\" id=\"visible\" />Visible<br />\n";
    if ( $GLOBALS['config']['pingback'] == '1' && empty($id) ){
        $str.='<input type="checkbox" name="pingback" value="1" checked="checked" class="pingback" id="pingback" />Pingback'."\n";
    }elseif ( $GLOBALS['config']['pingback'] == '1' ){
        $str.='<input type="checkbox" name="pingback" value="1" class="pingback" id="pingback" />Pingback'."\n";
    }
    if ( $GLOBALS['config']['useweblogping'] == '1' && empty($id) ){
        $str.='<br /><input type="checkbox" name="weblogping" value="1" class="weblogping" checked="checked" id="weblog" />Weblog.com&nbsp;Ping'."\n";
    }elseif ( $GLOBALS['config']['useweblogping'] == '1' ){
        $str.='<br /><input type="checkbox" name="weblogping" value="1" class="weblogping" id="weblog" />Weblog.com&nbsp;Ping'."\n</div>\n";
    }
    $str.="</div>\n";

    $str.="<a href=\"".$_SERVER['PHP_SELF']."\" accesskey=\"r\" title=\"Reset Page\"><img src=\"reset.png\" height=\"24\" width=\"24\" class=\"reset\"/></a>\n";
    if ( $id != NULL ){
        $str.='<input class="delete" type="image" src="delete.png" height="24" width="24" title="Delete" name="action" value="Delete" align="middle" class="delete" /></div>'."\n";
    }
    $str.="</div>\n<div class=\"clear\"> </div>\n</form>\n";
    print($str);
}

/*
    config() is the GUI configurator used by user.php
    The actual config is stored in the pingback database. As small as it is, there's no reason to dedicate a table to it.
*/
function
config(){
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    $sql="SELECT * FROM pingback where localid='-1'";
    $res = $db->query($sql);
    $configstr=$res->fetchRow();
    $configstr=$configstr[3];
    if ( $configstr == '' ){
        print("<p>Welcome to Parasite!</p>\n");
        $defaults=$GLOBALS['defaults'];
    }else{
        $configstr=stripslashes($configstr);
        $defaults=unserialize($configstr);
    }
    $str='<div id="config"><div>'."\n";
    $str.='<form action="'.$_SERVER['PHP_SELF'].'" method="post" name="config">'."\n";
    $str.='<label accesskey="l" for="limit" title="Limits the number of articles printed to the main page.">Limit: </label>'."\n";
    $str.='<input type="text" id="limit" size="1" name="limit" value="'.$defaults['limit'].'" class="limit" /><br />'."\n";
    $str.='<label accesskey="t" for="title" title="Your Blog\'s title. Will be used by the RSS feed.">Title: </label>'."\n";
    $str.='<input type="text" id="title" name="title" value="'.$defaults['title'].'" class="title" /><br />'."\n";
    $str.='<label accesskey="u" for="url" title="The URL for your blog.">URL: </label>'."\n";
    $str.='<input type="text" size="50" id="url" name="url" value="'.$defaults['url'].'" class="url" /><br />'."\n";
    $str.='<label accesskey="c" for="cssfile" title="Use this if you don\'t modify how main.php links to your CSS">CSS: </label>'."\n";
    $str.='<input type="text" size="50" id="cssfile" name="cssfile" value="'.$defaults['cssfile'].'" class="cssfile" /><br />'."\n";
    $str.='<label accesskey="d" for="description" title="The description of your blog will be used by your RSS feed.">Description: </label>'."\n";
    $str.='<input type="text" id="description" name="description" value="'.$defaults['description'].'" class="description" /><br />'."\n";

    $str.='<label accesskey="d" for="defaultuser" title="The default user that enters articles.">Default User: </label>'."\n";
    $str.='<input type="text" id="defaultuser" name="defaultuser" value="'.escape($defaults['defaultuser']).'" class="defaultuser" /><br />'."\n";
    $str.='<label accesskey="i" for="rssv2limit" title="The number of articles printed in the RSS V2 feed.">RSS Version 2 Limit: </label>'."\n";
    $str.='<input type="text" size="1" id="rssv2limit" name="rssv2limit" value="'.$defaults['rssv2limit'].'" class="rssv2limit" /><br />'."\n";

    $str.='<input type="checkbox" value="1" id="rssv2" name="rssv2" '.$defaults['rssv2str'].' class="rssv2">'."\n";
    $str.='<label accesskey="v" for="rssv2" title="See Docs for info on RSS versions.">RSSv2</label><br />'."\n";

    $str.='<input type="checkbox" name="pingback" value="1" '.$defaults['pingbackstr'].' id="usepingback" />';
    $str.='<label for="usepingback" title="Enable/Disable pingback feature">Use&nbsp;Pingback</label><br />'."\n";

    $str.='<input type="checkbox" name="useweblogping" value="1" '.$defaults['useweblogpingstr'].' id="useweblogping" />';
    $str.='<label for="useweblogping" title="Ping weblogs.com when you update your blog.">Use&nbsp;Weblog.com&nbsp;Ping</label><br />'."\n";

    $str.='<input type="checkbox" name="usearticletitles" value="1" '.$defaults['usearticletitlesstr'].' id="usearticletitles" onclick="rsscheck(); return true;" />';
    $str.='<label for="usearticletitles" title="Enable/Disable article titles.">Use&nbsp;Article&nbsp;Titles</label><br />'."\n";

    $str.='<a href="javascript:onclick=makevis(\'legend\');">Legend</a><br />'."\n";
    $str.='<div id="legend" class="legend" style="display:none">';
    $str.='<p>The definitions can contain any HTML and will replace the following keywords:</p><ul>'."\n";
    $str.='<li>|thisarticlenumber| The numeric ID of the article being printed</li>'."\n";
    $str.='<li>|thisarticletitle| The title of the article being printed</li>'."\n";
    $str.='<li>|thisarticledate| A formated time string of the article being printed</li>'."\n";
    $str.='<li>|thisarticleuser| The user that entered the article being printed</li>'."\n";
    $str.='<li>|thisarticlebody| The guts of the article being printed</li>'."\n";
    $str.='<li>|thisarticlepermalink| The permanent URI of the article being printed</li>'."\n";
    $str.='<li>|pingbackclass| This keyword will be replaced with &quot;invisible&quot; if no pingbacks exist and will be replaced with &quot;pingbacklist&quot; if pingbacks exist</li>'."\n";
    $str.='<li>|thisarticlepingbackid| This keyword will be replaced with &quot;pb&quot; and then the numeric ID of the article being printed. This keyword is provided to aid in scripting pingback display.</li>'."\n";
    $str.='<li>|thisarticlepingbacklist| This keyword will be replaced with the list of pingbacks to the current article. If no pingbacks occurred, this keyword is replaced with an empty string.</li>'."\n";
    $str.='<li>|thisarticlepingbacktotal| This keyword will be replaced with &quot;Pingbacks:&nbsp;&quot; and then the number of pingbacks that the current article has received. If no pingbacks have occurred, this keyword is replaced with an empty string.</li>'."\n";
    $str.="</ul>\n</div>\n";

    $str.='<label for="articledefinition" title="Defines how articles are printed. See Legend.">Article Definition: </label><br />'."\n";
    $str.='<textarea cols="50" rows="10" name="articledefinition" id="articledefinition">'.$defaults['articledefinition']."</textarea><br />\n";
    $str.='<label for="pingbacktotaldefinition" title="Defines how pingback totals are printed to articles, if used. See Legend.">Pingback Total Definition: </label><br />'."\n";
    $str.='<textarea cols="50" rows="10" name="pingbacktotaldefinition" id="pingbacktotaldefinition">'.$defaults['pingbacktotaldefinition']."</textarea><br />\n";
    $str.='<label for="pingbacklistdefinition" title="Defines how the list of pingbacks will be printed.">Pingback List Definition: </label><br />'."\n";
    $str.='<textarea cols="50" rows="10" name="pingbacklistdefinition" id="pingbacklistdefinition">'.$defaults['pingbacklistdefinition']."</textarea><br />\n";
    $str.='<input type="submit" name="action" class="saveconfig" accesskey="s" value="Save Config">'."\n";
    $str.="</form>\n</div>\n</div>\n";
    printf("%s",$str);
}

function
getconfig(){
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    $sql="SELECT * FROM pingback where localid='-1'";
    $res = $db->query($sql);
    $configstr=$res->fetchRow();
    if ( sizeof($configstr) == 0 ){
        $defaults=$GLOBALS['defaults'];
    }else{
        $configstr=stripslashes($configstr[3]);
        $defaults=unserialize($configstr);
    }
    $GLOBALS['config']=array_merge($GLOBALS['config'],$defaults);
    $db->disconnect();
}

/* 
    saveconfig() gets post data and converts it into a usable config array
*/
function
saveconfig($array){
    $ssa=array('title','description','defaultuser','articledefinition','pingbacklistdefinition','pingbacktotaldefinition');
    foreach( $ssa as $ele ){
        $array["$ele"]=stripslashes($array["$ele"]);
    }
    $hea=array('title','defaultuser','description');
    foreach( $hea as $ele ){
        $array["$ele"]=htmlspecialchars($array["$ele"]);
    }
    $ca=array('pingback','useweblogping','usearticletitles');
    foreach( $ca as $ele ){
        if ( $array["$ele"] == 1 ){
            $elestr=$ele.'str';
            $array["$elestr"]='checked="checked"';
        }else{
            $array["$ele"]=0;
        }
    }
    if ( $array['rssv2'] == '1' ){
        $array['rssv2str'] = 'checked="checked"';
        $array['rssversion'] = 2;
    }else{
        $array['rssv2str'] = '';
        $array['rssversion'] = 1;
    }
    // if the user doesn't have titles enabled, they can't use rssv2
    if ( $array['usearticletitles'] != '1' ){
        $array['rssv2str'] = 'disabled="disabled"';
        $array['rssversion'] = '1';
    }
        
    unset($array['action']);
    $str=serialize($array);
    $str=addslashes($str);
    $time=mktime();
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    // make sure we have a config entry in the DB
    $sql="SELECT * FROM pingback where localid='-1'";
    $res = $db->query($sql);
    $configstr=$res->fetchRow();
    if ( sizeof($configstr) == 0 ){
        $sql="INSERT INTO pingback VALUES ('$time','-1','config','$str')";
    }else{
        $sql="UPDATE pingback SET remotetitle='$str' WHERE remoteurl='config'";
    }
    $res = $db->query($sql) or die( $sql );
}

/*
    printarticle() is used to interpret $articledefinition in order to print
    articles, whenever necessary. This includes printing individual articles
    for the 'article' script as well as previews for user.php and, of course,
    the main page. 

    If $db is FALSE, pingback stuff will be left out.
*/

function
printarticle($user,$articletitle,$articlebody,$time,$id,$db){

    // for Previews
    if ( empty($time) ){
        $time=mktime();
    }

    $ad=$GLOBALS['config']['articledefinition'];

    $keywords['|thisarticletitle|']=$articletitle;
    $keywords['|thisarticleuser|']=$user;
    $keywords['|thisarticlenumber|']=$id;
    $keywords['|thisarticledate|']=date('l M j g:ia Y',$time);
    $keywords['|thisarticleurl|']=$GLOBALS['config']['articleurl'].'/'.$id;
    $keywords['|thisarticlepermalink|']='<a href="'.$GLOBALS['config']['articleurl'].'/'.$id.'">permalink</a>';

    while( list($key,$value)=each($keywords) ){
        $ad=str_replace("$key","$value",$ad);
    }

    if ( $db != FALSE && $GLOBALS['config']['pingback'] == 1 && !empty($id) ){
        $au=parse_url($GLOBALS['config']['articleurl']);
        $au=$au['path'];
        //get the pingbacks out of the DB and create a string out of them
        $sql="SELECT * FROM pingback where localid=$id";
        $res = $db->query($sql);
        $sop = $res->numRows();
        if ( $sop > 0 ){
            if( preg_match('/|thisarticlepingbacktotal|/',$ad) > 0 ){
                $ptdstr = pingbacktotal($sop,$keywords);
                $ad=str_replace('|thisarticlepingbacktotal|',"$ptdstr",$ad);
                $ad=str_replace('|thisarticlepingbackid|',$id.'pingbacks',$ad);
            }
            if( preg_match('/|thisarticlepingbacklist|/',$ad) > 0 ){
                $plstr = pingbacklist($res,$keywords);
                $ad=str_replace('|thisarticlepingbacklist|',$plstr,$ad);
                $ad=str_replace('|pingbackclass|','pingbacklist',$ad);
                $ad=str_replace('|thisarticlepingbackid|',$id.'pingbacks',$ad);
            }
        }else{
            $ad=str_replace('|pingbackclass|','invisible',$ad);
            $ad=str_replace('|thisarticlepingbacktotal|','',$ad);
            $ad=str_replace('|thisarticlepingbacklist|','',$ad);
            $ad=str_replace('|thisarticlepingbackid|',"pb$id",$ad);
        }
    }else{
        $ad=str_replace('|pingbackclass|','invisible',$ad);
        $ad=str_replace('|thisarticlepingbacktotal|','',$ad);
        $ad=str_replace('|thisarticlepingbacklist|','',$ad);
        $ad=str_replace('|thisarticlepingbackid|',"pb$id",$ad);
    }

    // BODY MUST ALWAYS GO LAST!
    $ad=str_replace('|thisarticlebody|',"$articlebody",$ad);
    print($ad);
}

/* pingbacktotal is called by printarticle(). It returns a string that is 
   $pingbacktotaldefinition converted into useable HTML. */

function
pingbacktotal($sop,$keywords){
    global $pingbacktotaldefinition;

    $ad = $GLOBALS['config']['pingbacktotaldefinition'];
    while( list($key,$value)=each($keywords) ){
        $ad=str_replace("$key","$value",$ad);
    }
    $ptdstr=str_replace('|pingbacktotal|',$sop,$ad);
    return $ptdstr;
}

/* pingbacklist is called by printarticle(). It returns a string that is 
   $pingbacklistdefinition converted into useable HTML. */

function
pingbacklist($res,$keywords){
    $plarray[]="Pingbacks:<br />\n";
    while ($pingbackitem = $res->fetchRow()) {
        // time, localid,remoteurl,remotetitle
        $pingbacktime=date('l M j g:ia Y',$pingbackitem[0]);
        $pltemp=str_replace('|thispingbacktime|',"$pingbacktime",$GLOBALS['config']['pingbacklistdefinition']);
        $pltemp=str_replace('|thispingbackremoteurl|',"$pingbackitem[2]",$pltemp);
        $pltemp=str_replace('|thispingbackremotetitle|',"$pingbackitem[3]",$pltemp);
        $plarray[]=$pltemp;
        unset($pltemp);
    }
    $plstr=implode('',$plarray);
    while( list($key,$value)=each($keywords) ){
        $plstr=str_replace("$key","$value",$plstr);
    }

    return $plstr;
}

/* 
    This function gets the five most recent VISIBLE articles and, by default,
    prints them to the main page. If $type is set to 'rss1' or 'rss2' it will
    create the respective RSS feed by calling rssprint() instead of 
    articleprint().
*/

function
fetchem($type="main",$seid=0){

    if ( $type == "rss2" ){
        $limit=$GLOBALS['config']['rssv2limit'];
    }else{
        $limit=$GLOBALS['config']['limit'];
    }
    $limitconstant=$GLOBALS['config']['limitconstant'];

    if ( isset($_GET['startart']) ){
        $startart=$_GET['startart'];
        $displayhome=1;
    }else{
        $startart = 0;
    }


    /*  get the amount of visible articles since we're not really deleting 
        articles, this number won't equate to the highest article ID number. 
        numvisarticles() returns an array of article id numbers       */
    $db = DB::connect( $GLOBALS['config']['dbstring'] );

    if ( $type != 'search' ){
        $artnum=numvisarticles(1,$db);
    }else{
        if ( is_array($_SESSION['searches']) ){
            foreach( $_SESSION['searches'] as $value ){
                if ( $value['seid'] == $seid ){
                    $artnum = array_values($value['ids']);
                    $terms  = $value['terms'];
                    $displayhome = 1;
                }
            }
        }else{
            foreach( $GLOBALS['searches'] as $value ){
                $artnum = array_values($value['ids']);
                $terms  = $value['terms'];
                $displayhome = 1;
            }
        }
    }

    $soa=sizeof($artnum);
    if ( $soa == 0 ) {
        return;
    }
    if ( $soa > 0 ){
        rsort($artnum,SORT_NUMERIC);
        reset($artnum);
    }

    if ( $soa < ($startart+$limitconstant) ){
        $startart=$soa-$limitconstant;
        if ( $startart < 0 ){
            $startart = 0 ;
        }
    }

    $limit=$limit+$startart;

    // If the limit is greater than th number of articles, lower it.
    if($soa<$limit){
        $limit=$soa;
    }

    if ( $type != 'search' ){
        $rss1article=$artnum[$startart];
        $rss1ts=getarticleitem('time',$rss1article,$db);
        // Last-Modified: Thu, 20 Jun 2002 13:58:42 GMT
        $timestring = date('r',$rss1ts);
        header ("Last-Modified: $timestring");
    }

    if ( $type == "rss1" ){
        $rss1=getarticleitem('body',$rss1article,$db);
        rssprint('rss1',$rss1);
        $db->disconnect();
        exit;
    }

    for($x=$startart;$x<$limit;$x++){
        if ( $type == 'rss2' ){
            $tmp['title']=getarticleitem('title',$artnum[$x],$db);
            if ( $tmp['title'] == '' ){
                $tempb=getarticleitem('body',$artnum[$x],$db);
                if ( $tempb != ''){
                    $tmp['title'] = sscanf( strip_tags($tempb) ,"%s %s %s %s %s");
                    $tmp['title'] = trim( implode(' ',$tmp['title']) );
                    $tmp['title'] .= '...';
                }
            }
            $tmp['title']=htmlspecialchars($tmp['title']);
            $tmp['id']=$artnum[$x];
            $tmp['pubDate']=getarticleitem('time',$artnum[$x],$db);
            $rss2[]=$tmp;
            unset($tmp);
        }else{
            $a=getarticle($artnum[$x],$db);
            if ( $type == 'search' ){
                $a['body'] = highlight_terms($terms,$a['body']);
                $a['title'] = highlight_terms($terms,$a['title']);
            }
            if ( $a['body'] != FALSE ){
                printarticle($a['user'],$a['title'],$a['body'],$a['time'],$artnum[$x],$db);
            }
        }
    }
    
    if ( $type == 'rss2' ){
        rssprint('rss2',$rss2);
        $db->disconnect();
        exit;
    }

    $star=$limitconstant+$startart;

    // if we're searching and we haven't already displayed all of the results:
    if ( $type == 'search' ){
        $qq      = urlencode(stripslashes($_REQUEST['q']));
        $numpages  = ceil($soa / $limitconstant);
        $currpage  = ceil(($startart+$limitconstant) / $limitconstant);
        $pages     = range(1,$numpages);
        $newq = 'q='.$qq.'&amp;startart=';
        $str = "<div id=\"searchpaging\"><p>Search Results:<br />\n";
        foreach ( $pages as $page ){
            if ( $page == $currpage ){
                $str .= ' '.$page.' ';
            }else{
                $fsa  = $page * $limitconstant -$limitconstant;
                $linktitle = 'Page '.$page.' of results for '.htmlentities(stripslashes($_REQUEST['q'])).' ('.$soa.' total)';
                $str .= ' <a href="'.$GLOBALS['config']['url'].'?'.$newq.$fsa.'" title="'.$linktitle.'">'.$page.'</a>'."\n\n";
            }
        }
        $str .= "</p></div>\n";
        printf("%s",$str);
    }

    if( $type != 'search' && $soa != $limit ){
        printf("<a href=\"%s?startart=%d\">Older&nbsp;Articles</a><br />\n",$GLOBALS['config']['url'],$star);
    }
    if ( $displayhome == 1 ){
        printf("<a href=\"%s\" title=\"%s\" accesskey=\"h\">Home</a><br />\n",$GLOBALS['config']['url'],$GLOBALS['config']['title']);
    }

    $db->disconnect();
}

/* 
    magic() is called from main.php. It is used to keep logic out of main.php
    It inerprets any POST/GET arguments and acts accordingly. If there are no
    POST/GET arguments, it prints the main page.
*/

function
magic(){

    if ( basename($_SERVER['SCRIPT_NAME']) == "article" ){
        $expl = explode("/",$_SERVER["REQUEST_URI"]);
        $article_id = $expl[count($expl)-1];
        lonearticle($article_id);
        printf("<a href=\"%s\" title=\"%s\" accesskey=\"h\">Home</a><br />\n",$GLOBALS['config']['url'],$GLOBALS['config']['title']);
        return;
    }
    if ( isset($_REQUEST['q']) && trim($_REQUEST['q']) != '' ){
        session_start();
        $seid=search($_REQUEST['q']);
        if ( $seid != FALSE ){
            fetchem('search',$seid);
        }else{
            return FALSE;
        }
    }else{
        fetchem();
    }
}

function
user_init(){
    if ( $GLOBALS['editorversion'] != $GLOBALS['functionsversion'] ){
        print("Version mismatch.\n");
        exit;
    }
    if ( isset( $_FILES['rtupload'] ) ){
        if( isset( $_FILES['rtupload']['error'] ) ){
            $error = error_check( $_FILES['rtupload']['error'] );
        } elseif( $_FILES['rtupload']['size'] > 300000 ){
            $error = error_check("File size too big. Discarding.");
        } elseif ( file_exists( $_FILES['rtupload']['tmp_name'] ) ){
            if ( $_FILES['rtupload']['type'] == "application/octet-stream" || $_FILES['rtupload']['type'] == "text/html" || $_FILES['rtupload']['type'] == "text/plain" ){
                $contents = file( $_FILES['rtupload']['tmp_name'] );
                $GLOBALS['contents'] = implode('',$contents);
                $GLOBALS['uploadpreview'] = 1;
            }else{
                $str = "Wrong file type [".$_FILES['rtupload']['type']."]! File type must be application/octet-stream or text/plain or text/html.";
                $error = error_check($str);
                unset($str);
            }
        }
    }

    if ($_POST['action'] != "Preview" && $_POST['action'] != "SpellCheck" ){
        if($_POST['action']=="Delete"){
            changevisibility($_POST['id'],"d");
        }elseif ( !empty($_POST['id']) ){
            $id=$_POST['id'];
            $articlebody=$_POST['articlebody'];
            $userx=$_POST['user'];
            $titlex=$_POST['articletitle'];
            $visiblex=$_POST['visible'];
            $pingbackx=$_POST['pingback'];

            $error = update_article($id,$articlebody,$userx,$titlex,$visiblex,$pingbackx);
            $error = error_check($error);

            if($visiblex==1){
                changevisibility($id,1);
            }else{
                changevisibility($id,0);
            }

            if(isset($_POST['timechange'])){
                $time=time();
                update_articletime($id,$time);
            }
            if ( $_POST['weblogping'] == 1 ){
                $wperror = weblog_ping();
                $error = error_check($wperror);
                if ( is_array($werror) ){
                    $werror=implode('',$werror[1]);
                }
                $error .= $werror;
            }
        }elseif ( isset($_POST['articlebody']) ){
            $articlebody=$_POST['articlebody'];
            $visible=$_POST['visible'];
            $pingback=$_POST['pingback'];
            $user=$_POST['user'];
            $articletitle=$_POST['articletitle'];

            $time=time();
            if ( $visible !=1 ){
                $visible=0;
            }
            if ( $pingback!= 1 || $usepingback == 0 ){
                $pingback= 0;
            }
            $error = publish_article($time,$articlebody,$visible,$user,$articletitle,$pingback);
            $error = error_check($error);
            if ( $_POST['weblogping'] == 1 ){
                $wperror = weblog_ping();
                $error = error_check($wperror);
            }
            unset($time,$articlebody,$visible,$user,$articletitle,$pingback);
        }
    }
}

function
user_magic(){
    if ( $GLOBALS['editorversion'] != $GLOBALS['functionsversion'] ){
        print("Version mismatch.\n");
        exit;
    }
    printf("<p class=\"error\">\n%s\n</p>\n",$GLOBALS['config']['errors']);
    if ( isset($_POST['editme'] ) ){
        $editme=$_POST['editme'];
        if(empty($editme)){
            unset($editme);
        }
        if( $editme>$GLOBALS['highestarticleid'] || ! is_numeric($editme ) ){
            unset($editme);
            articlemaint();
        }else{
            if (isset($editme)){
                articlemaint($editme);
            }
        }
    } elseif ( $_POST['action'] == "Preview" ){
        $user=stripslashes($_POST['user']);
        $articletitle=stripslashes($_POST['articletitle']);
        $articlebody=stripslashes($_POST['articlebody']);
        $id=stripslashes($_POST['id']);
        print('<div id="articlepreview">'."\n");
        printarticle($user,$articletitle,$articlebody,$time,$id,FALSE);
        print('</div>'."\n");
        word_count($articlebody);
        articlemaint($id,$articlebody,$user,$articletitle);
    } elseif ($_POST['action'] == 'SpellCheck' ){
        include('SpellChecker.class.php');
        $user=stripslashes($_POST['user']);
        $articletitle=stripslashes($_POST['articletitle']);
        $articlebody=stripslashes($_POST['articlebody']);
        $text = htmlentities($articlebody);
        $id=stripslashes($_POST['id']);
        $sp = new SpellChecker('aspell');
        $num_errors = $sp->check($text);
        if ($num_errors > 0) {
            $errors = $sp->getErrors();
            $oldtext = $text;
            foreach ($errors as $word => $suggestions) {
                $title = trim(implode(', ', $suggestions));
                $span = '<|||'.$title.'|||>'.$word.'</||>';
                # $text = str_replace($word, $span, $text);
                $text = preg_replace("/(\W|^)$word(\W|\$)/i", "$1$span$2", $text);
            }
            $text = str_replace('<|||', '<span class="speling" title="', $text);
            $text = str_replace('|||>', '">', $text);
            $text = str_replace('</||>', '</span>', $text);
            $text = nl2br($text);
            // print '<pre>'; print_r($sp->errors); print '</pre>';
            $s = ($num_errors == 1) ? '' : 's';
            print '<div class="spellingerrors">'."\n";
            print "<p><strong>{$num_errors} possible error{$s} found...</strong></p>\n\n";
            print "<div class=\"displaytext\">".$text."</div>";
            print '</div>'."\n";
        }else{
            print '<div class="spellingerrors">'."\n";
            print'<p>0 errors found.</p>'."\n";
            print '</div>'."\n";
        }
        articlemaint($id,$articlebody,$user,$articletitle);
    } elseif ( $GLOBALS['uploadpreview'] == 1 ){
        $user=$GLOBALS['config']['defaultuser'];
        $articletitle='';
        $articlebody=$GLOBALS['contents'];
        $id="01010101";
        print('<div id="articlepreview">'."\n");
        printarticle($user,$articletitle,$articlebody,$time,$id,FALSE);
        print('</div>'."\n");
        word_count($articlebody);
        articlemaint($id,$articlebody,$user,$articletitle);
    } elseif ( isset($_POST['listall']) ){
        if ( $_POST['listall'] == "List All Articles" ) {
            listall();
        }elseif ( $_POST['listall'] == "List Deleted Articles" ){
            listall('d');
        }elseif ( $_POST['listall'] == "List Postponed Articles" ){
            listall('0');
        }
    } elseif ( $_POST['action'] == 'Upload' ){
        $str = '<div class="uploaddiv">';
        if ( $GLOBALS['config']['usearticletitles'] == '1' ){
            $str .= "\n<p>Don't forget to add a title!</p>\n";
        }
        $str .= '<p>Max file size: 300,000 bytes.</p>'."\n";
        $str .= '<form enctype="multipart/form-data" action="'.$_SERVER['PHP_SELF'].'" method="post">'."\n".'<input type="hidden" name="MAX_FILE_SIZE" value="300000">'."\n".'<label for="fileup">Upload file:</label><input name="rtupload" id="fileup" type="file">'."\n".'<input type="submit" value="Upload File" class="uploadfile">'."\n</form></div>\n";
        printf( "%s",$str);
        unset($str);
    } elseif ( $_POST['action'] == 'Config' ){
        config();
    } elseif ( $_POST['action'] == 'Save Config' ){
        saveconfig( $_POST );
        getconfig();
        articlemaint();
    }else{
        articlemaint();
    }
}

function
word_count($str){
    // Hey, talk to Darrell Golliher. He wanted it.
    $e = strip_tags($str);
    $e = str_replace("\n",' ',$e);
    $e = explode(' ',$e);
    $e = array_filter($e,'trim');
    $e = array_filter($e,'notempty');
    $wc=sizeof($e);
    $str = '<p class="wc">'.$wc.' words.</p>'."\n";
    print($str);
}

function
title(){

    if ( basename($_SERVER['SCRIPT_NAME']) == "article" ){
        $expl = explode("/",$_SERVER["REQUEST_URI"]);
        $id = $expl[count($expl)-1];
        $db = DB::connect( $GLOBALS['config']['dbstring'] );
        $articletitle=getarticleitem("title",$id,$db);
        $db->disconnect();
        $title .= $GLOBALS['config']['title']."  :: $articletitle";
        printf('%s',$title);
    }else{
        printf('%s',$GLOBALS['config']['title']);
    }
}

/*  
    lastfew() can be called by the user to display the last few articles
    limited by $int. The user should call this funciton like so:
    <? lastfew(5); ?> 
*/
function
lastfew($int){
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    $limit=$GLOBALS['config']['limit'];
    $limitconstant=$GLOBALS['config']['limitconstant'];

    $artnum=numvisarticles(1,$db);
    if ( $soa == 0 ) {
        return;
    }

    $soa=sizeof($artnum);
    if ( $soa > 0 ){
        rsort($artnum,SORT_NUMERIC);
        reset($artnum);
    }

    // If the limit is greater than th number of articles, lower it.
    if($soa<$limit){
        $limit=$soa;
    }
    $artnum = array_slice($artnum,$limit);
    $soa = sizeof($artnum);
    if( $soa == 0 ){
        return FALSE;
    }
    if( $soa < $int ){
        $int = $soa ;
    }
    $artnum = array_slice($artnum,0,$int);
    $str = '';
    foreach ( $artnum as $id ){
        $title = getarticleitem('title',$id,$db);
        if ( $title == '' ){
            $body = getarticleitem('body',$id,$db);
            if ( $body != ''){
                $title = sscanf( strip_tags($body) ,"%s %s %s %s %s");
                $title = trim( implode(' ',$title) );
                $title .= '...';
            }
        }
        $str .= '<a href="'.$GLOBALS['config']['articleurl'].'/'.$id.'" title="'.$title.'">'.$title."</a><br />\n";
    }
    $db->disconnect();
    print($str);
}

/*
    rssprint() is used by fetchem(). I realize it's lame, don't blame me,
    blame PHP's poor and ever-changing XML support. Hey, it works!
*/

function
rssprint($type,$data){
    if ( $type == 'rss1' ){
        if ( $data != ''){
            $rsstitle = sscanf( strip_tags($data) ,"%s %s %s %s %s");
            $rsstitle = trim( implode(' ',$rsstitle) );
            $rsstitle .= '...';
            $rsstitle = preg_replace('/&nbsp;/s',' ',$rsstitle);
        }else{
            $rsstitle = "wtf";
        }
        /*
        $rsstitle=trim( substr( strip_tags($data) ,0,100) );
        $rsstitle=ereg_replace('&nbsp;',' ',$rsstitle);
        $rsstitle.="...";
        */
    }

    print("<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n");
    print("<rdf:RDF\n");
    print(" xmlns:rdf=\"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\n");
    print(" xmlns=\"http://my.netscape.com/rdf/simple/0.9/\"\n>\n");

    print("\t<channel>\n");
    print("\t  <language>en</language>\n");
    printf("\t  <title>%s</title>\n",$GLOBALS['config']['title']);
    printf("\t  <description>%s</description>\n",$GLOBALS['config']['description']);
    printf("\t  <link>%s</link>\n",$GLOBALS['config']['url']);
    print("\t</channel>\n");

    if ( !empty($GLOBALS['config']['rssimgurl']) ){
        print("\t\t<image>\n");
        printf("\t\t\t<title>%s</title>\n",$GLOBALS['config']['title']);
        printf("\t\t\t<url>%s</url>\n",$GLOBALS['config']['rssimgurl']);
        printf("\t\t\t<link>%s</link>\n",$GLOBALS['config']['url']);
        print("\t\t</image>\n");
    }

    if ( $type == 'rss2' ){
        foreach ( $data as $a ){
            print("\t\t<item>\n");
            printf("\t\t  <title>%s</title>\n",$a['title']);
            printf("\t\t  <link>%s/%s</link>\n",$GLOBALS['config']['articleurl'],$a['id']);
            printf("\t\t  <pubDate>%s</pubDate>\n",date('r',$a['pubDate']));
            print("\t\t</item>\n");
        }
    }else{
        print("\t\t<item>\n");
        printf("\t\t  <title>%s</title>\n",$rsstitle);
        printf("\t\t  <link>%s</link>\n",$GLOBALS['config']['url']);
        print("\t\t</item>\n");
    }
    print("</rdf:RDF>\n");
}

/* 
    lonearticle() is called by the 'article' script and is for displaying one 
    article at a time.
*/

function
lonearticle($id){
    $db = DB::connect( $GLOBALS['config']['dbstring'] );

    $visible=numvisarticles(1,$db);
    if ( sizeof($visible) == 0 ){ $db->disconnect(); return; }
    rsort($visible,SORT_NUMERIC);
    reset($visible);
    while(list(,$value)=each($visible)){
        if ( $id == $value ){
            $found=TRUE;
        }
    }
    if ( ! $found ){
        print("<p>\nArticle no longer exists.\n\n</p>\n");
        return;
    }

    $a=getarticle($id,$db);
    $timestring = date('r',$a);
    header ("Last-Modified: $timestring");

    printarticle($a['user'],$a['title'],$a['body'],$a['time'],$id,$db);
    $db->disconnect();
}

/* 
    Since most (all?) modern browsers render HTML-escaped characters in a
    <textarea></textarea>, rather than leaving them escaped, one must 
    double-escape them... turning &quot; into &amp;quot;. escape() does that.
    It takes and returns a string.
    This could probably be done easily with preg_replace, but I suck with 
    regex. :P
*/

function
escape($s){
    
    // If you add one, leave off the semi-colon (';')
    $ents[]='&nbsp';
    $ents[]='&quot';
    $ents[]='&amp';
    $ents[]='&lt';
    $ents[]='&gt';

    $pointer=0;
    $ampfound=0;
    $len=strlen($s);
    
    while($pointer<$len){
        $escapefound=strpos( $s , "&" , $pointer );

        if ( $escapefound === false ) break;

        // The shortest escaped char is &lt; which is 4 chars
        $pointer=$escapefound+3;

        while (($pointer < $len) && (($s[$pointer] != ';') && ($s[$pointer] != "\n")) ){
            $pointer++;
        }

        $char=substr($s, $escapefound, ($pointer - $escapefound) );
        while( list(,$value)=each($ents) ){
            if ( $char == $value ) {
                $s=substr($s,0,$escapefound+1)."amp;".substr($s,$escapefound+1);
                $len += 4;
            }
        }
        reset($ents);
    }

    return $s;
}

/*
    notempty() is called by array_filter() to get rid of empty array elements.
*/

function
notempty($s){
    return (!empty($s));
}

/* 
    searchterms() takes a string and returns an array of search terms.
    The string is cleansed of crazy characters and various checks are 
    done to verify that things are sane. Quoted strings are treated
    as one search term. There are no +term and -term goodies, yet.
*/

function
searchterms($searchterms){

    $searchterms=stripslashes($searchterms);
    $searchterms=stripslashes($searchterms);
    $searchterms=str_replace('/','',$searchterms);
    if ( $searchterms == '' ){
        print("<p>\nEmpty Search.\n</p>\n");
        printf("<a href=\"%s\" title=\"%s\" accesskey=\"h\">Home</a><br />\n",$GLOBALS['config']['url'],$GLOBALS['config']['title']);
        return FALSE;
    }
    $searchterms=strtolower($searchterms);

    // Look for "quoted terms"
    // preg_match_all populates $quotes with the matches it finds
    // then remove the quoted term from the $searchterm string
    // then remove the quote characters from the quoted term
    if (preg_match_all("/\"[^\"]*\"/",$searchterms,$quotes) > 0 ){
        $searchterms=str_replace($quotes[0],"",$searchterms);
        $quotes=str_replace("\"","",$quotes[0]);
    }
    if ( empty($quotes[0]) ){
        unset($quotes);
    }

    // create an array of the serch terms minus any quoted terms from above
    $terms=explode(" ",$searchterms);

    // get rid of any empty array elements
    $termx=array_filter($terms,'notempty');

    // re-key the array
    $terms=array_values($termx);

    // add quoted terms back into the array as single elements
    if ( isset($quotes) ){
        $terms=array_merge($terms,$quotes);
    }
    $terms = preg_replace('/[+]/','',$terms);
    if ( implode('',$terms) == '' ){
        print("<p>\nPunctuation only searches not allowed.\n</p>\n");
        printf("<a href=\"%s\" title=\"%s\" accesskey=\"h\">Home</a><br />\n",$GLOBALS['config']['url'],$GLOBALS['config']['title']);
        return FALSE;
    }
    $punct = "',[{}\]|()^%*&$`~.";
    $terms = preg_replace('+['.$punct.']+','',$terms);
    if ( implode('',$terms) == '' ){
        print("<p>\nPunctuation only searches not allowed.\n</p>\n");
        printf("<a href=\"%s\" title=\"%s\" accesskey=\"h\">Home</a><br />\n",$GLOBALS['config']['url'],$GLOBALS['config']['title']);
        return FALSE;
    }
    return $terms;
}

/*
    search() is, you guessed it, the search function. It takes search terms 
    as a string. It passes that string off to searchterms() above. If our
    searcher doesn't have cookies enabled, $_SESSION won't be available to us.
    If $_SESSION *is* available, we'll check to see if the user has already
    done this search. If so, we'll bypass the search immediately and hand off
    to fetchem(). If not, we search through all articles for our search terms.
    If we find results, they (search terms, search results, and a timestamp)
    are stored (as an array)  in $_SESSION, if available, and $GLOBALS if 
    $_SESSION isn't available. If $_SESSION is available, and the user alters 
    her search or searches for something else, ALL of the results, searchterms 
    and a timestamp are stored in $_SESSION.  $time is the UNIX timestamp of the
    search and is returned in case $_SESSION is available. If $_SESSION is
    available, the timestamp is the unique identifier that allows fetchem() to
    determine what entry in the array to use.
*/

function
search($str){
    $terms=searchterms($str);

    if ( $terms === FALSE ){
        return FALSE;
    }

    if ( is_array($_SESSION['searches']) ){
        foreach( $_SESSION['searches'] as $oldterms ){
            if ( $oldterms['terms'] == $terms ){
                return $oldterms['seid'];
            }
        }
    }

    $time=mktime();

    // connect to the database and find out the largest article ID
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    $highestarticleid = getmaxid($db);

    // from the highest article id we can determine our factor
    // the factor is what gives search results rank, the ones with
    // the most matches have the highest score.
    // if we have 500 articles, $factor should be 1000
    // 5000 articles would have a factor of 10,000 and so on.
    $factor=pow(10,strlen($highestarticleid));

    // then get the number of visible articles
    $artnum=numvisarticles("1",$db);
    $soa=sizeof($artnum);
    if ( $soa > 0 ){
        rsort($artnum,SORT_NUMERIC);
        reset($artnum);
    }

    // loop through the visible articles and search for our terms

    $score=0;
    for($x=0;$x<$soa;$x++){

        $id=$artnum[$x];
        $a=getarticle($id,$db);
        
        $tempbody=strip_tags($a['body']);

        // search titles as well. Since we're just using this string
        // as a search blob, it doesn't really matter where the title
        // is added.
        $tempbody=$tempbody.$a['title'];
        $tempbody=strtolower($tempbody);

        // loop through the search terms, every match increase the score
        while( list(,$value)=each($terms) ){
            if ( preg_match("~$value~",$tempbody) > 0 ){
                $score++;
            }
        }
        reset($terms);

        if ( $score > 0 ){
            // create a key for a new array of articles that is the
            // expanded "score" of the search.
            $arraykey=($score * $factor) + $id;

            // add the $id to the array of search results and reset $score
            $searchresults[$arraykey]=$id;
            $score=0;
        }
        unset($a);
    }
    if ( ! is_array($searchresults) ){
        print("<p>\nNo Results.\n</p>\n");
        printf("<a href=\"%s\" title=\"%s\" accesskey=\"h\">Home</a><br />\n",$GLOBALS['config']['url'],$GLOBALS['config']['title']);
        return FALSE;
    }
    reset($searchresults);
    reset($terms);

    // if $_SESSION isn't an array, the user has cookies turned off
    // and we need to act differently.
    $nosessions = 0;
    if ( !is_array($_SESSION['searches']) ){
        $nosessions = 1;
    }
    $sestemp['terms']         = $terms;
    $sestemp['ids']           = $searchresults;
    $sestemp['seid']          = $time;
    if ( $nosessions == 0 ){
        $searches             = $_SESSION['searches'];
    }
    $sos                      = sizeof($searches)+1;
    $searches[$sos]           = $sestemp;
    if ( $nosessions == 0 ){
        $_SESSION['searches'] = $searches;
    }else{
        $GLOBALS['searches']  = $searches;
    }
    return $time;
}

/*  highlight_terms is used by fetchem() to highlight search terms 
    in search results. $terms is an array of terms to be highlighted
    and $str is the string to highlight. */

function
highlight_terms($terms,$str){
    if ( !is_array($terms) ){
        return FALSE;
    }
    if ( empty($str) ){
        return FALSE;
    }

    $str = '<p>'.$str.'</p>';

    while( list(,$value)=each($terms) ){
        $str = preg_replace("/(\>(((?>[^><]+)|(?R))*)\<)/ie", "preg_replace('/(?>$value+)/i','<span class=\"searchword\">$value</span>','\\0')",$str);
    }

    // remove the tags we added prior to searching:
    $str = substr($str,3,-4);
    $str = stripslashes($str);
    return $str;
}


/* 
    listall() is used by user.php. It lists a small summary of every article
    using either the title, if available, or the first 50 chars of the article
    body if the title is not available. 
    If $type is defined, listall will search for either postponed or deleted
    articles ('p' or 'd' respectively.)
*/

function
listall($type="all"){
    $db = DB::connect( $GLOBALS['config']['dbstring'] );
    $sql = "SELECT max(id) FROM articles";
    $max = $db->query($sql) or die( $sql );
    $maxRow = $max->fetchRow();
    $highestarticleid = $maxRow[0];

    if ( $highestarticleid == 0 ){
        print("No articles.\n");
        exit;
    }

    printf("<form method=\"post\" name=\"f\" action=\"%s\">\n",$_SERVER['PHP_SELF']);

    if ( $type != 'all' ){
        $articles=numvisarticles($type,$db);
    }else{
        $articles=range(1,$highestarticleid);
    }

    $articles=array_reverse($articles);
    foreach ( $articles as $id ){
        uiprint($id,$db);
    }
    print("</form>\n");
    printf("<a href=\"%s\" accesskey=\"r\">Reset</a>",$_SERVER['PHP_SELF']);
}

/*
    uiprint() takes an article ID and prints a <submit> element with the 
    title (or the first few chars if no title is available). It is used by
    user.php and the listall() function.
*/

function
uiprint($id,$db){
    $title=getarticleitem("title",$id,$db);
    if ( ! empty($title) ){
        printf("<input type=\"submit\" name=\"editme\" value=\"%s\" class=\"editme\" />&nbsp;<span class=\"articlelist\">%s</span><br />\n",$id,$title);
    }else{
        $body=getarticleitem("body",$id,$db);
            if ( $body != '' ){
                $title = sscanf( strip_tags($body) ,"%s %s %s %s %s");
                $title = trim( implode(' ',$title) );
                $title .= '...';
            }
        printf("<input type=\"submit\" name=\"editme\" value=\"%s\" class=\"editme\" />&nbsp;<span class=\"articlelist\">%s</span><br />\n",$id,$title);
    }
}

function
pingbackcheck($str,$id){
    $pingbackversion="1.0";

    $str=trim($str);
    $str=stripslashes($str);
    $str=preg_replace("/\n/",' ',$str);
    // Find anything that starts with http:// or https:// and is surrounded
    // by quotation marks.
    if ( preg_match_all('|"(http(s?)://[^"]+)"|',$str,$urls) > 0 ){
        $urls=$urls[0];
        $urls=array_filter($urls,'notempty');
        reset($urls);
        foreach ( $urls as $idx=>$purl ){
            $len=strlen($purl)-2;
            $urls[$idx]=substr($purl,1,$len);
        }

        // see if any of the URL's are local urls.
        $len=strlen($GLOBALS['config']['url']);
        foreach ( $urls as $idx=>$purl ){
            if ( strncmp($url,$purl,$len) == 0 ){
                unset($urls[$idx]);
            }
        }
        foreach ( $urls as $remote ){
            $agent = new ua("Parasite pingback v$pingbackversion",TRUE);
            $agent->set_info(array($remote));
            $agent->send_request($remote,FALSE);
            $agents[]=$agent;
            unset($agent);
        }
        foreach ( $agents as $idx=>$agent ){
            $info=implode('',$agent->get_info());
            $agent->get_reply();
            $agent->chunked_decode();
            if ( $agent->RC=='200' ){
                $remotecontent=$agent->Content;
                $remoteheaders=$agent->Header;
                if ( isset($remoteheaders['x-pingback']) ){
                    $pingbackserver=$remoteheaders['x-pingback'];
                }else{
                    $rcn=preg_replace("/\n/",' ',$remotecontent);
                    // take the contents and replace it all down to the 
                    // pingback server's URL
                    if( ! strstr($rcn,'<link rel="pingback"') ){
                        continue;
                    }
                    $pingbackserver=preg_replace('|.*<link rel="pingback" href="([^"]+)".*|',"$1",$rcn);
                    // If it's still the same as before, we didn't find a
                    // pingback server
                    if ( $pingbackserver == $remotecontent ){
                        continue;
                    }
                }
                $pingbackserver=trim($pingbackserver);
                if ( empty($pingbackserver) ){
                    $error = "No pingback server at ".$remote;
                    $error = error_check($error);
                    continue;
                }
                $psi=parse_url($pingbackserver);
                $pingbacksite=$psi['host'];
                $pingbacklocation=$psi['path'].$psi['query'];
                $local=XMLRPC_prepare($GLOBALS['config']['articleurl'].'/'.$id);
                $remoteurl=XMLRPC_prepare($info);
                $params=array($local,$remoteurl);
                $result=XMLRPC_request($pingbacksite,$pingbacklocation,"pingback.ping",$params, "Parasite Pingback v$pingbackversion");

                $result = error_check($result);
            }else{
                $error .= "Return code ".$agent->RC." for ".$remote;
                $error = error_check($error);
                continue;
            }
        }
    }else{
        return "No Pingback URLS found.\n";
    }
    return $error;
}

/* http://www.xmlrpc.com/weblogsCom */

function
weblog_ping(){
    global $pingbackversion;

    $weblogpingsite="rpc.weblogs.com";
    $weblogpinglocation="/RPC2";
    $title=XMLRPC_prepare($GLOBALS['config']['title']);
    $wlurl=XMLRPC_prepare($GLOBALS['config']['url']);
    $params=array($title,$wlurl);

    $result=XMLRPC_request($weblogpingsite,$weblogpinglocation,"weblogUpdates.ping",$params, "Parasite weblogUpdates Ping v$pingbackversion");

    return $result;
}

function 
XMLRPC_method_not_found($methodName){
    XMLRPC_error("2", "The method you requested, '$methodName', was not found.", WEBLOG_XMLRPC_USERAGENT);
    exit;
}

/*
create table pingback( time int NOT NULL, localid int NOT NULL, remoteurl
varchar(200) NOT NULL, remotetitle text NULL );
*/


function
pingback_ping($params){
    global $pingbackversion;

    $remote=$params[0];
    $local=$params[1];
    if ( empty($remote) || empty($local) ){
        XMLRPC_error('0','Empty Args!');
        exit;
    }
    $time=time();

    $aulen=strlen($GLOBALS['config']['articleurl']);
    if ( strncmp($remote,$GLOBALS['config']['articleurl'],$aulen) == 0 ){
        XMLRPC_error('0','Remote is local.');
        exit;
    }

    /* 
        Bob's blog receives a ping from Alice's blog (the ping sent in step 6
        above), naming http://alice.example.org/#p123  (the site linking to
        Bob) and http://bob.example.net/#foo (the page Alice linked to).
    */

    $local=trim($local);
    if ( ! strncmp($local,$GLOBALS['config']['articleurl'],$aulen) == 0 ){
        //0x0020 (32) The specified target URI does not exist. This MUST
        //be used only when the target definitely does not exist , rather than
        //when the target may exist but is not recognised.
        XMLRPC_error('32','Incorrect target');
        exit;
    }

    /* 
        Bob's blog confirms that http://bob.example.net/#foo is in fact a post
        on this blog.
    */
    $localid=str_replace($GLOBALS['config']['articleurl'].'/',"",$local);
    if ( ! is_numeric($localid) ){
        //0x0020 (32) The specified target URI does not exist. This MUST
        //be used only when the target definitely does not exist , rather than
        //when the target may exist but is not recognised.
        XMLRPC_error('32','Incorrect Article ID');
        exit;
    }
    // check to make sure this article is valid/visible.
    $db = DB::connect( $GLOBALS['config']['dbstring']);
    $visible=numvisarticles('1',$db);

    if ( ! in_array($localid,$visible) ){
        //0x0020 (32) The specified target URI does not exist. This MUST
        //be used only when the target definitely does not exist , rather than
        //when the target may exist but is not recognised.
        XMLRPC_error('32','Article no longer exists');
        exit;
    }

    /*
        It then requests the content of http://alice.example.org/#p123 and
        checks the Content-Type of the entity returned to make sure it is text
        of some sort. 
    */
    $remote=trim($remote);
    sleep(1);
    $agent = new ua("Parasite Pingback v$pingbackversion",TRUE);
    $agent->set_info(array($remote));
    $agent->send_request($remote,FALSE);
    $info=implode('',$agent->get_info());
    $agent->get_reply();
    $agent->chunked_decode();
    if ( $agent->RC=='200' ){
        $remotecontent=$agent->Content;
        $remoteheaders=$agent->Header;
    }elseif ($agent->RC=='404' ){
        //0x0010 (16) The source URI does not exist
        XMLRPC_error('16','404');
        exit;
    }else{
        //A generic fault code. Servers MAY use this error code instead of any
        //of the others if they do not have a way of determining the correct
        //fault code.
        $rc="Error ".$agent->RC." fetching your URL";
        XMLRPC_error('0',"$rc");
        exit;
    }
    if ( strncmp($remoteheaders['content-type'],"text/html",9) != 0 ){
        //A generic fault code. Servers MAY use this error code instead of any
        //of the others if they do not have a way of determining the correct
        //fault code.
        XMLRPC_error('0','Bad content type');
        exit;
    }
    /*
        It verifies that this content does indeed contain a link to
        http://bob.example.net/#foo (to prevent spamming of pingbacks).

        Bob's blog also retrieves other data required from the content of
        Alice's new post, such as the page title, an extract of the page
        content surrounding the link to Bob's post, any attributes indicating
        which language the page is in, and so forth.
    */
    $remo=preg_replace("/\n/",' ',$remotecontent);
    if ( preg_match("|$local|",$remo) ){
        $remoteurl=$remote;
        // Thanks Happy!
        $remotetitle=preg_replace("|.*<title>(.*)</title>.*|","$1",$remo);
        $remotetitle=htmlentities($remotetitle);
        $remotetitle=trim($remotetitle);
        if ( empty($remotetitle) ){
            $remotetitle="No Title";
        }
    }else{
        //0x0011 (17) The source URI does not contain a link to the target URI,
        //and so cannot be used as a source.
        XMLRPC_error('17','No link found');
        exit;
    }

    /*
        Finally, Bob's post records the pingback in its database, and
        regenerates the static pages referring to Bob's post so that they
        mention the pingback.
    */


    // Check to see if there is already a pingback from this URL
    $ssql="SELECT remoteurl FROM pingback where localid=$localid";
    $existingpings = $db->query($ssql) or die( $ssql );
    while ($pings = $existingpings->fetchRow()) {
        $existing=$pings[0];
        if ( $existing === $remote ){
            //0x0030 (48) The pingback has already been registered.
            $error = XMLRPC_error('48',"Already Registered $this $remote");
            exit;
        }
    }

    /*
    create table pingback( time int NOT NULL, localid int NOT NULL, remoteurl
    varchar(200) NOT NULL, remotetitle text NULL );
    */

    $insertsql="INSERT INTO pingback VALUES('$time','$localid','$remoteurl','$remotetitle')";
    $insert=$db->query($insertsql) or die($insertsql);
    $insert = fuckedup($time,$localid,$remoteurl,$remotetitle,$db);
    $db->disconnect();
    XMLRPC_response('Success.',WEBLOG_XMLRPC_USERAGENT);
    exit;
}

function
error_check($mixed){
    if ( is_array($mixed) ){
        // XMLRPC error message usually have TRUE as the first element, if 
        // the request was successful, so we can ignore those "errors"
        if ( is_array($mixed[1]) ){
            $str = implode('',$mixed[1]);
            if ( $str == '1' ){
                return '';
            }
            $GLOBALS['config']['errors'] .= $str.'<br />';
        }else{
            $str = implode('',$mixed);
            if ( $str == '1' ){
                return '';
            }
            $GLOBALS['config']['errors'] .= $str.'<br />';
        }
    }else{
            if ( $mixed == '1' ){
                return '';
            }
        $GLOBALS['config']['errors'] .= $mixed.'<br />';
    }
    return '';
}

function
debug_grab($label='',$mixed='FLARRRR'){
    ob_start( $s );
        printf("%s",$label);
        if ( $mixed != 'FLARRRR' ){
            var_dump( $mixed );
        }
    $str = ob_get_contents();
    ob_end_clean( $s );
    $GLOBALS['config']['debugstr'] .= $str;
}

function
debugend(){
    printf ("<textarea cols=\"80\" rows=\"30\">%s</textarea>\n",$GLOBALS['config']['debugstr']); 
    $GLOBALS['config']['debugsrt']='';
}

function
debugwrite($file,$mode='w'){
    $fp = fopen($file,$mode);
    if (!$fp){
        die ("Can't open file!\n");
    }
    $len = strlen($GLOBALS['config']['debugstr']);
    $ret = fputs($fp,$GLOBALS['config']['debugstr'],$len);
    $GLOBALS['config']['debugsrt']='';
}

/*  
    The following two classes were found at http://www.2113.ch/phplab/
    Please check out http://fravia.2113.ch/phplab/ and 
    http://www.searchlores.org/ for more of their great code.
*/


//This class is written by DQ.
//I call it 'DQ's turbo socket class' and believe me, it's not an 
//abusive name :-)
//It offers an easy way to work with php socket
//Its main advantage against standard php fsockopen() & co. functions is 
//SPEEEEEEEEEEEEEED !!

class socket {
  #public:
  var $errno=0;
  var $errstring='';
  #private:
  var $fp=0;
  var $sleeptime=0.5;   // minimum time between two successive reads
  var $nextread=0;
  var $timeout=0;       // checks when there's nothing more to read
  var $post_tout;
  var $buffer='';       // internal data buffer

  // changed pre_tout from 10 to 1
  function socket($hostname,$port,$fsock_tout=10,$pre_tout=1,$post_tout)
  {
    if(empty($fsock_tout)||($fsock_tout<1)) $fsock_tout=10;
    $this->fp=fsockopen($hostname,$port,$this->errno,$this->errstring,$fsock_tout);
    if($this->fp) {
      socket_set_blocking($this->fp,FALSE);
      // changed pre_tout from 10 to 1
      if(empty($pre_tout)||($pre_tout<1)) $pre_tout=1;
      if(empty($post_tout)||($post_tout<1)) $post_tout=$pre_tout;
      $this->post_tout=$post_tout;
      list($micro,$secs)=explode(' ',microtime());
      $now=$secs+$micro;
      $this->timeout=$now+$pre_tout;   // set initial timeout (usually longer)
    } // end if
  } // end function socket (constructor)

  function eof()
  {
    //end of file will be reached when connection is closed AND when buffer is empty
    return(($this->fp==FALSE) && empty($this->buffer));
  }

  //This routine will fill the buffer. It must be called from every state 
  //transition functions like data_available, receive_complete, read, ... 
  //in order to keep checking for the connection state

  function internal_read()
  {
    $result='';
    list($micro,$secs)=explode(' ',microtime());
    $now=$secs+$micro;
    if($now<$this->nextread) {
      usleep($this->sleeptime*1000000);         // avoid server overload
      $now+=$this->sleeptime;                   // update $now with new time
    } // end if
    $this->nextread=$now+$this->sleeptime; // mark earliest time for next read
    if($this->fp) {
      fread($this->fp,0);//bug workaround: we need to fread() to get updated socket_get_status()!
      $fp_stat=socket_get_status($this->fp);
      $avail=$fp_stat['unread_bytes'];
      if($avail>0) {
        $this->timeout=$now+$this->post_tout;
        $result=fread($this->fp,$avail);
      } else if($fp_stat['eof']||($now>=$this->timeout)) $this->close();
    } // end if
    return($result);
  }

  //Will return true when the connection is closed.
  //Either because of the end of reception or either because the 
  //connection could never be opened
  function receive_complete()
  {
   $this->buffer.=$this->internal_read(); //Let's check if any data available
   if ($this->fp==FALSE) return TRUE; else return FALSE;//If communication is over, fp is set to FALSE
  }

  //Will return true when some data are available in the buffer.
  //Or when the connection is over  !!!
  //This is needed in case the connection could never be opened. 
  //We should prevent infinite loop for data when there can't be any data !!
  function data_available()
  {
    $this->buffer.=$this->internal_read(); //Let's check if any data available
    //any data in the buffer ? or communication closed ?
    return (($this->fp==FALSE) || (strlen($this->buffer)>0));
  }

  function read()
  {
    if ($this->data_available()) $result=$this->buffer; else $result='';
    $this->buffer='';
    return ($result);
    //$result=empty($this->buffer)?($this->internal_read()):($this->buffer);
    //$this->buffer='';
    //return($result);
  }

  function readline()
  {
    $result='';
    while(1) {
      $p=strpos(' '.$this->buffer,"\n");
      if($p) {
        $result=substr($this->buffer,0,$p);
        $this->buffer=substr($this->buffer,$p);
        break;
      } // end if
      if($this->fp==FALSE) {//End of connection. Nothing more to expect.
        $result=$this->buffer;// send back everything collected up to now
        $this->buffer='';//Need to clear buffer once it's read
        break;
      } // end if
      $this->buffer.=$this->internal_read();
    } // end while
    return($result);
  }

  function write($line)
  {
    if($this->fp) fwrite($this->fp,$line);
  }

  function close()
  {
    if($this->fp) fclose($this->fp);
    $this->fp=FALSE;
  }
}; // end class socket

/*
class user agent. Ask him to fetch a page for you

modification :
- 14/02/01 : added 'chunked_decode()' function to correctly handle 
chunked transfer-encoding

require('t_socket_2.inc'); // We need DQ's turbo socket to connect to the world
Version 2 support simultaneous connections
*/

class ua {
    var $RC = 0;         //HTTP return code
    var $RCString = '';  //HTTP return string

    var $Header='';      //Header array
    var $Content='';     //Page content (string)
    var $name = 'my little bot';

    //Private
    var $f = '';         //our t_socket
    var $info = array(); //some info we will carry on
    var $UseDNScache;


    function ua($ua='', $DNSMode=TRUE)
    {
        if (isset($ua)&& !empty($ua)) $this->name = $ua;
        if (isset($DNSMode)) $this->UseDNScache = $DNSMode;
    }

    //This should prevent many redundant dns query
    function gethostIP($aHost)
    {
        static $hosts;//static to allow hosts to be shared between all instances
        if (count($hosts)>0) {
            foreach($hosts as $host => $IP) if ($host==$aHost)  return $IP;
        }
        $IP = gethostbyname($aHost);
        if ($this->UseDNScache) $hosts[$aHost]=$IP;//check if we use a DNS cache
        return $IP;
    }

    function send_request($url,$headonly=false)
    {
        if (($url_array=parse_url($url)) !=FALSE) {
            $host = $url_array['host'];
            $hostip = $this->gethostIP($host);     //5/12/2000

            if (!isset($url_array['path'])) $url_array['path'] = '/';
            $this->f=new socket($hostip,80,20,20,20);
            if (!($this->f->eof())) {
                $this->f->write((($headonly)?"HEAD":"GET")." ".$url_array['path']);
                if (isset($url_array['query'])) $this->f->write('?'.$url_array['query']);
                $this->f->write(" HTTP/1.1\r\n");
                $this->f->write('Host: '.$url_array['host']."\r\n" );
                $this->f->write('User-Agent: '.$this->name."\r\n" );
                //Needed to tell the server to close the connection once the transfer is over. This speed up things
                $this->f->write("Connection: close\r\n");
                $this->f->write("Accept: */*\r\n" );
                $this->f->write( "\r\n" );
                return;         //Everything went fine, let's just return
            } else {
                $this->RC = -1;
                $this->RCString = $this->f->errstring;
            }
        } else {
            $this->RC=-1;
            $this->RCString='malformed URL';
        }
        $this->f->close();//Let's close the socket to indicate the communication is done
        unset($this->f);
    }

    function data_available() {
        if (!isset($this->f)) return true;//If the socket couldn't be opened we shouldn't wait for any reply
        //return $this->f->data_available();
        return $this->f->receive_complete();
    }

    function get_reply()
    {
        if (isset($this->f)) {  //Any socket to get data from ?
        if (!($this->f->eof())) { $Status = $this->f->readline();}
        if (preg_match('@(\d{3}) (.*)@',$Status,$reg_array)) {
            $this->RC = $reg_array[1];
            $this->RCString = $reg_array[2];
        }
        while(!($this->f->eof())) {
            $line = $this->f->readline();
            if ($line=="\r\n") break;
            list($name, $val) = explode(': ',$line);
            if (empty($val)) {$val = 'N/A';}
            $this->Header[strtolower($name)]=trim($val);
        }
        while (!($this->f->eof())) { $this->Content.=$this->f->readline();}
            $this->f->close();//Let's close the socket to tell communication is over
            unset($this->f);
        }
    }

    //Return a specific header content
    function GetHeader($name)
    {
        if (isset($this->Header[$name])) return $this->Header[$name];
        else return '';
    }

    //Some function to allow to carry on some information about the page we are fetching
    function set_info($var)
    {
        if (is_array($var)) $this->info=array_merge($this->info, $var);
    }

    function get_info()
    {
        return $this->info;
    }

    //This function will decode the "chunked' transfer coding
    //as defined in RFC2068 19.4.6
    function chunked_decode()
    {
        if ($this->getHeader('transfer-encoding')!='chunked') return;
        $buffer=$this->Content;
        $length = 0;
        $new='';
        $chunkend = strpos($buffer,"\r\n")+2;
        $temp = substr($buffer,0,$chunkend);
        $chunk_size=hexdec(trim($temp));
        $chunkstart=$chunkend;
        while ($chunk_size > 0) {
            $chunkend=strpos($buffer,"\r\n",$chunkstart+$chunk_size);
            if ($chunkend==FALSE) { //Just in case we got a broken connection
                $chunk=substr($buffer,$chunkstart);
                $new.=$chunk;
                $length+=strlen($chunk);
                break;
            }
            $chunk=substr($buffer,$chunkstart,$chunkend-$chunkstart);
            $new.=$chunk;
            $length += strlen($chunk);
            $chunkstart=$chunkend+2;
            $chunkend=strpos($buffer,"\r\n",$chunkstart)+2;
            if ($chunkend==FALSE) break; //Just in case we got a broken connection
            $temp=substr($buffer,$chunkstart,$chunkend-$chunkstart);
            $chunk_size=hexdec(trim($temp));
            $chunkstart=$chunkend;
        }
        //Any additional header : not implemented yet
        //      read entity-header
        //      while (entity-header not empty) {
        //       append entity-header to existing header fields
        //       read entity-header
        //      }
        //Update headers
        $this->Header['content-length'] = $length;
        unset($this->Header['transfer-encoding']);
        $this->Content=$new;
    }
};     //end class ua

// End code from http://www.2113.ch/

?>
